/*
 *   ApeTAGǂݍ݂̉
 */
#include "APETag.h"
#include "myapeTag.h"

typedef void*pAPE_TAG;

#define MEMEQ(p1,p2,n) (memcmp((p1),(p2),(n))==0)

typedef struct{
	APE_TAG_FOOTER footer;  // apetag footer structure;
	HANDLE hFile;    // handle of file
	BYTE* cData;     // pointer to buffer of tagbody.(exclude header/footer)
	DWORD nDataSize; // sizeof cData's size.(exclude header/footer)
} APE_TAG;


static BOOL ReadApeTagHeader(HANDLE hFile,APE_TAG* apetag){
	DWORD read;
	SetFilePointer(hFile,-APE_TAG_FOOTER_BYTES,NULL,FILE_END); // seek backword from FILE_END // TODO: Implement Error Handler.

	BYTE buf[APE_TAG_FOOTER_BYTES];
	if( ReadFile(hFile,buf,APE_TAG_FOOTER_BYTES,&read,0) != TRUE ){
		return FALSE;
	}
	if(read != APE_TAG_FOOTER_BYTES){return FALSE;}
	memcpy(apetag->footer.m_cID,buf,8);
	apetag->footer.m_nVersion = *( (int*)(buf+ 8) ); // TODO: FIXGfBAˑ
	apetag->footer.m_nSize = *( (int*)(buf+12) );
	apetag->footer.m_nFields = *( (int*)(buf+16) );
	apetag->footer.m_nFlags = *( (int*)(buf+20) );
	memcpy(apetag->footer.m_cReserved,buf+24,8);
	return TRUE;
}

// return the pointer to (index)th field name.
// field name is NULL terminated string.
// pointer is available until CloseApeTag.
static char* ApeTag_GetFieldName(pAPE_TAG tag,int index){
	APE_TAG* apetag = (APE_TAG*)tag;
	if(index >= apetag->footer.m_nFields)return NULL; // ݂Ȃindex

	int i=0;
	BYTE* p = apetag->cData;
	DWORD FieldNameLen = 0;
	DWORD ValueSize = 0;


	for(i=0;i<index;i++){
		if(p >= ((apetag->cData)+(apetag->nDataSize))){return NULL;} // tB[hobt@zĂꍇ
		ValueSize = *((int*)p); // TODO: FIX GfBAˑ
		p += 4+4; // valuesize,flags
		p = (BYTE*)strchr((char*)p,'\0'); // find end of field name
		p++; // pass '\0'
		p += ValueSize; // pass value
	}
	if(p >= ((apetag->cData)+(apetag->nDataSize))){return NULL;} // tB[hobt@zĂꍇ
	p += 4+4;
	return (char*)p;
}

// return the pointer to (index)th field value.
// pointer is available until CloseApeTag.
static BYTE* ApeTag_GetFieldValue(pAPE_TAG tag,int index,LPDWORD vSize){
	APE_TAG* apetag = (APE_TAG*)tag;
	if(index >= apetag->footer.m_nFields)return NULL; // ݂Ȃindex

	int i=0;
	BYTE* p = apetag->cData;
	DWORD FieldNameLen = 0;
	DWORD ValueSize = 0;

	if(vSize){*vSize = 0;}
	for(i=0;i<index;i++){
		if(p >= ((apetag->cData)+(apetag->nDataSize))){return NULL;} // tB[hobt@zĂꍇ
		ValueSize = *((int*)p); // TODO: FIX GfBAˑ
		p += 4+4; // valuesize,flags
		p = (BYTE*)strchr((char*)p,'\0'); // find end of field name
		p++; // pass '\0'
		p += ValueSize; // pass value
	}
	if(p >= ((apetag->cData)+(apetag->nDataSize))){return NULL;} // tB[hobt@zĂꍇ
	ValueSize = *((int*)p); // TODO: FIX GfBAˑ
	p += 4+4; // valuesize,flags
	p = (BYTE*)strchr((char*)p,'\0'); // find end of field name
	p++; // pass '\0'
	if(p+ValueSize > ((apetag->cData)+(apetag->nDataSize))){return NULL;} // tB[hobt@zĂꍇ
	if(vSize){*vSize = ValueSize;}
	return p;
}

static CueCharset ApeTag_GetFieldCharset(pAPE_TAG tag,int index){
	return CUECHAR_UTF8;
}

// ŗ^ꂽapetagheaderLǂׂB
// ͊ȈՃ`FbN̂
static BOOL ValidApeTagHeader(APE_TAG* apetag){
	if( !MEMEQ(apetag->footer.m_cID,"APETAGEX",8) ){return FALSE;}
	if( apetag->footer.m_nSize >=  1024*1024*16 ){return FALSE;} // TODO: FIXbl
	return TRUE;
}


static DWORD ApeTag_GetFieldNumber(pAPE_TAG tag){
	APE_TAG* apetag = (APE_TAG*)tag;
	return apetag->footer.m_nFields;
}

// apetagǂݏo
static pAPE_TAG OpenApeTag(HANDLE hFile){
	APE_TAG* apetag = NULL;
	DWORD read = 0;

	apetag = (APE_TAG*)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sizeof(APE_TAG));
	if(apetag == NULL)return NULL;
	apetag->cData = NULL;
	if( ReadApeTagHeader(hFile,apetag) == FALSE ){goto failed;}
	if( ValidApeTagHeader(apetag) == FALSE ){goto failed;}
	apetag->nDataSize = (apetag->footer.m_nSize)-APE_TAG_FOOTER_BYTES;

	apetag->cData = NULL;
	if( (apetag->cData = (BYTE*)HeapAlloc(GetProcessHeap(),0,apetag->nDataSize)) == NULL ){
		goto failed;
	}
	SetFilePointer(hFile,-apetag->footer.m_nSize,NULL,FILE_END);
	if( ReadFile(hFile,apetag->cData,apetag->nDataSize,&read,0) == FALSE){
		goto failed;
	}
	if( read != apetag->nDataSize ){
		goto failed;
	}
	apetag->hFile = hFile;
	return apetag;

failed:
	HeapFree(GetProcessHeap(),0,apetag->cData);
	HeapFree(GetProcessHeap(),0,apetag);
	return NULL;	
}

static void CloseApeTag(pAPE_TAG tag){
	APE_TAG* apetag = (APE_TAG*)tag;
	HeapFree(GetProcessHeap(),0,apetag->cData);
	HeapFree(GetProcessHeap(),0,apetag);
}

const TAG_READER_INTERFACE apeIF = {OpenApeTag, ApeTag_GetFieldNumber, ApeTag_GetFieldName, ApeTag_GetFieldValue, ApeTag_GetFieldCharset, CloseApeTag};