/*
 *   FlacTAGǂݍ݂̉
 */
#include "myflacTag.h"

#define MEMEQ(p1,p2,n) (memcmp((p1),(p2),(n))==0)

#define FLAC_MARKER "fLaC"
#define FLAC_BLOCK_TYPE_VORBIS_COMMENT 4

typedef void*pFLAC_TAG;

typedef struct{
	char marker[4]; // "fLaC"
} FLAC_TAG_HEADER;

typedef struct{
	FLAC_TAG_HEADER header;  // flactag footer structure;
	HANDLE hFile;    // handle of file
	BYTE* cData;     // pointer to buffer of tagbody.(exclude header/footer)
	DWORD nDataSize; // sizeof cData's size.(exclude header/footer)
} FLAC_TAG;


static BOOL ReadFlacTagHeader(HANDLE hFile,FLAC_TAG* flactag){
	DWORD read;
	SetFilePointer(hFile,0,NULL,FILE_BEGIN); // TODO: Implement Error Handler.
	
	if( ReadFile(hFile,flactag->header.marker,4,&read,NULL) != TRUE ){
		return FALSE;
	}

	return TRUE;
}

// return the pointer to (index)th field name.
// field name is NULL terminated string.
// pointer is available until CloseFlacTag.
static char* FlacTag_GetFieldName(pFLAC_TAG tag,int index){
	FLAC_TAG* flactag = (FLAC_TAG*)tag;
	DWORD venderLength;
	DWORD listLength;
	DWORD length;
	venderLength = *((DWORD*)(flactag->cData));
	listLength = *((DWORD*)(flactag->cData+4+venderLength));

	char* p;
	char* pEqual;
	int i;
	
	if(index >= listLength){
		return NULL;
	}

	p = (char*)flactag->cData+4+venderLength+4;

	for(i=0;i<index;i++){
		length = *((DWORD*)p);
		p += 4;
		if( pEqual = strchr(p,'=') ){
			*(pEqual) = '\0';
		}
		p += length;
	}
	p += 4;
	if( pEqual = strchr(p,'=') ){
		*(pEqual) = '\0';
	}
	return p;
}

// return the pointer to (index)th field value.
// pointer is available until CloseFlacTag.
static BYTE* FlacTag_GetFieldValue(pFLAC_TAG tag,int index,LPDWORD vSize){
	FLAC_TAG* flactag = (FLAC_TAG*)tag;
	DWORD venderLength;
	DWORD listLength;
	DWORD length;
	venderLength = *((DWORD*)(flactag->cData));
	listLength = *((DWORD*)(flactag->cData+4+venderLength));

	char* p;
	char* pEqual;
	int i;
	
	if(vSize){*vSize = 0;}
	if(index >= listLength){
		return NULL;
	}

	p = (char*)flactag->cData+4+venderLength+4;

	for(i=0;i<index;i++){
		length = *((DWORD*)p);
		p += 4;
		if( pEqual = strchr(p,'=') ){
			*(pEqual) = '\0';
		}
		p += length;
	}
	length = *((DWORD*)p);
	p += 4;
	if( pEqual = strchr(p,'=') ){
		*(pEqual) = '\0';
	}
	if(vSize){*vSize = length - strlen(p) -1;}
	return (BYTE*)strchr(p,'\0')+1;
}

static CueCharset FlacTag_GetFieldCharset(pFLAC_TAG tag,int index){
	return CUECHAR_UTF8;
}

// ŗ^ꂽflactagheaderLǂׂB
// ͊ȈՃ`FbN̂
static BOOL ValidFlacTagHeader(FLAC_TAG* flactag){
	if( !MEMEQ(flactag->header.marker, FLAC_MARKER, 4) ) {
		return FALSE;
	}
	return TRUE;
}


static DWORD FlacTag_GetFieldNumber(pFLAC_TAG tag){
	FLAC_TAG* flactag = (FLAC_TAG*)tag;
	DWORD venderLength;
	DWORD count;
	venderLength = *((DWORD*)(flactag->cData));
	count = *((DWORD*)(flactag->cData+4+venderLength));
	return count;
}

// flactagǂݏo
static pFLAC_TAG OpenFlacTag(HANDLE hFile){
	FLAC_TAG* flactag = NULL;
	DWORD read = 0;

	flactag = (FLAC_TAG*)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sizeof(FLAC_TAG));
	if(flactag == NULL)return NULL;
	flactag->cData = NULL;
	if( ReadFlacTagHeader(hFile,flactag) == FALSE ){goto failed;}
	if( ValidFlacTagHeader(flactag) == FALSE ){goto failed;}
	
	BYTE metadataBlockHeader[4];
	BOOL lastMetadataFlag = FALSE;
	BYTE blockType = 0;
	long length = 0;

	SetFilePointer(hFile,4,NULL,FILE_BEGIN);
	while(lastMetadataFlag == FALSE){
		if( ReadFile(hFile,metadataBlockHeader,4,&read,0) == FALSE){
			goto failed;
		}
		if( read != 4 ){goto failed;}
		lastMetadataFlag = ((metadataBlockHeader[0]&0x80) ? TRUE : FALSE);
		blockType = metadataBlockHeader[0]&0x7f;
		length = ((long)metadataBlockHeader[1]<<16)+((long)metadataBlockHeader[2]<<8)+(long)metadataBlockHeader[3];
		if( blockType == FLAC_BLOCK_TYPE_VORBIS_COMMENT ){
			flactag->cData = (BYTE*)HeapAlloc(GetProcessHeap(),0,length);
			if(flactag->cData == NULL)goto failed;
			ReadFile(hFile,flactag->cData,length,&read,NULL);
			flactag->hFile = hFile;
			if(read != length)goto failed;
			flactag->nDataSize = length;
			return flactag;
		}else{
			SetFilePointer(hFile,length,0,FILE_CURRENT);
		}
	}
	return NULL;

failed:
	HeapFree(GetProcessHeap(),0,flactag->cData);
	HeapFree(GetProcessHeap(),0,flactag);
	return NULL;	
}

static void CloseFlacTag(pFLAC_TAG tag){
	FLAC_TAG* flactag = (FLAC_TAG*)tag;
	HeapFree(GetProcessHeap(),0,flactag->cData);
	HeapFree(GetProcessHeap(),0,flactag);
}

const TAG_READER_INTERFACE flacIF = {OpenFlacTag, FlacTag_GetFieldNumber, FlacTag_GetFieldName, FlacTag_GetFieldValue, FlacTag_GetFieldCharset, CloseFlacTag};
